//+------------------------------------------------------------------+
//|                                                      MiniMax.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    Vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "Vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 1

#property indicator_color1 Yellow

//---- input parameters

extern int iPeriod=3;
extern int Shift=0;


//---- buffers

double MidleBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorDigits(Digits+1); 
   //---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,iPeriod);
   SetIndexShift(0,Shift);
//---- indicator buffers mapping
   SetIndexBuffer(0,MidleBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("_Midle("+iPeriod+")");
   SetIndexLabel(0,"_Midle"+iPeriod);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
int start() {
   int   limit,
         counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for (int i=limit; i>0; i--) 
      MidleBuffer[i]=(High[iHighest( NULL, 0, MODE_HIGH, iPeriod, i)]+Low[ iLowest(  NULL, 0, MODE_LOW,  iPeriod, i)])/2;
   return(0);
}